Attribute VB_Name = "mEnumWindows"
Option Explicit

Private Declare Function EnumWindows& Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long)
Private Declare Function EnumChildWindows& Lib "user32" (ByVal hParent As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long)
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long

Dim tv As TreeView
Dim m_ClassName As String
Dim sParent As String
Dim bFirstChild As Boolean
Dim ndParent As Node, ndRoot As Node

Function EnumWinProc(ByVal hWnd As Long, ByVal lParam As Long) As Long
   sParent = GetWndText(hWnd)
   If sParent = "No caption" Then sParent = GetWndText(GetTopLevelParent(hWnd))
   If sParent = "No caption" Then sParent = sParent & " (Class = " & GetWndClass(GetTopLevelParent(hWnd)) & ")"
   bFirstChild = True
   Call EnumChildWindows(hWnd, AddressOf EnumChildWinProc, lParam)
   EnumWinProc = 1
End Function

Function EnumChildWinProc(ByVal hWnd As Long, ByVal lParam As Long) As Long
   Dim s As String
   s = GetWndClass(hWnd)
   Select Case s
       Case "SysTreeView32", "SysListView32", "SysHeader32", "ToolbarWindow32"
       Case Else: GoTo NextLoop
   End Select
   If bFirstChild Then
      bFirstChild = False
      Set ndParent = tv.Nodes.Add(ndRoot, tvwChild, , sParent)
   End If
   With tv.Nodes.Add(ndParent, tvwChild, , s & " (0x" & Right("00000000" & Hex(hWnd), 8) & ")")
        .Tag = hWnd
   End With
NextLoop:
   EnumChildWinProc = 1
End Function

Public Function GetWndClass(hWnd As Long) As String
  Dim k As Long, sName As String
  sName = Space$(128)
  k = GetClassName(hWnd, sName, 128)
  If k > 0 Then sName = Left$(sName, k) Else sName = "No class"
  GetWndClass = sName
End Function

Private Function GetWndText(hWnd As Long) As String
  Dim k As Long, sName As String
  sName = Space$(128)
  k = GetWindowText(hWnd, sName, 128)
  If k > 0 Then sName = Left$(sName, k) Else sName = "No caption"
  GetWndText = sName
End Function

Public Sub GetWindowList(tvw As TreeView)
   Set tv = tvw
   Set ndRoot = tv.Nodes.Add(, , , "Windows with image lists")
   EnumWindows AddressOf EnumWinProc, 0
   ndRoot.Expanded = True
   Set ndParent = Nothing
   Set ndRoot = Nothing
End Sub

Private Function GetTopLevelParent(hWnd As Long) As Long
  Dim hwndParent As Long
  Dim hwndTmp As Long
  
  hwndParent = hWnd
  Do
    hwndTmp = GetParent(hwndParent)
    If hwndTmp Then hwndParent = hwndTmp
  Loop While hwndTmp

  GetTopLevelParent = hwndParent

End Function


