Attribute VB_Name = "mSBDuplicate"
Option Explicit

Private Type ITEM_TEXT
   pszText As String * 80
End Type

Private Const SBARS_SIZEGRIP = &H100

Private Const WM_USER = &H400&
Private Const SB_GETTEXT = (WM_USER + 2)
Private Const SB_GETTEXTLENGTH = (WM_USER + 3)
Private Const SB_GETPARTS = (WM_USER + 6)
Private Const SB_GETBORDERS = (WM_USER + 7)
Private Const SB_SIMPLE = (WM_USER + 9)
Private Const SB_GETRECT = (WM_USER + 10)
Private Const SB_ISSIMPLE = (WM_USER + 14)
Private Const SB_GETTIPTEXT = (WM_USER + 18)
Private Const SB_GETICON = (WM_USER + 20)

Private Const SBT_NOBORDERS = &H100
Private Const SBT_POPOUT = &H200
Private Const SBT_RTLREADING = &H400
Private Const SBT_NOTABPARSING = &H800
Private Const SBT_OWNERDRAW = &H1000

Public Function SB_Duplicate(ByVal hSB As Long, sb As StatusBar) As Long
   
   Dim tid As Long, pid As Long, hProcess As Long
   Dim nCount As Long, i As Long, lStyle As Long, lBevel As Long, ret As Long
   Dim rcAddr As Long, bdrAddr As Long, itAddr As Long, lWritten As Long
   Dim hIcon As Long
   Dim sText As String, sTip As String, sSbrInfo As String
   Dim bIsSimple As Boolean
   Dim arrBorders(2) As Long
   Dim sPic As StdPicture
   
   Dim rc As RECT
   Dim it As ITEM_TEXT
   
   sb.Panels.Clear
   lStyle = GetWindowLong(hSB, GWL_STYLE)
   
   nCount = SendMessage(hSB, SB_GETPARTS, 0, ByVal 0)
   If nCount = 0 Then Exit Function
   bIsSimple = SendMessage(hSB, SB_ISSIMPLE, 0, ByVal 0)
   If bIsSimple Then
      sb.Style = sbrSimple
      nCount = 1
   Else
      sb.Style = sbrNormal
   End If
   If Not EnableDebugPrivNT Then Exit Function
   tid = GetWindowThreadProcessId(hSB, pid)
   If pid = 0 Then Exit Function
   hProcess = OpenProcess(PROCESS_ALL_ACCESS, False, pid)
   If hProcess = 0 Then Exit Function
   
   bdrAddr = VirtualAllocEx(hProcess, 0, 12, MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE)
   Call SendMessage(hSB, SB_GETBORDERS, 0, ByVal bdrAddr)
   Call ReadProcessMemory(hProcess, ByVal bdrAddr, arrBorders(0), 12, lWritten)
   VirtualFreeEx hProcess, ByVal bdrAddr, 0, MEM_RELEASE
   
   sSbrInfo = nCount & "_" & lStyle
   sSbrInfo = sSbrInfo & "_" & arrBorders(0) & "_" & arrBorders(1) & "_" & arrBorders(2)
   sb.Tag = sSbrInfo
   
   rcAddr = VirtualAllocEx(hProcess, 0, Len(rc), MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE)
   itAddr = VirtualAllocEx(hProcess, 0, Len(it), MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE)
   For i = 0 To nCount - 1
       sText = "": sTip = ""
       ZeroMemory rc, Len(rc)
       ZeroMemory it, Len(it)
       
       Call WriteProcessMemory(hProcess, ByVal itAddr, it, Len(it), lWritten)
       ret = SendMessage(hSB, SB_GETTEXT, i, ByVal itAddr)
       lBevel = HiWord(ret)
       Call ReadProcessMemory(hProcess, ByVal itAddr, it, Len(it), lWritten)
       sText = TrimNull(it.pszText)
       Call SendMessage(hSB, SB_GETTIPTEXT, i, ByVal itAddr)
       Call ReadProcessMemory(hProcess, ByVal itAddr, it, Len(it), lWritten)
       sTip = TrimNull(it.pszText)
       If bIsSimple Then sb.SimpleText = sText
       
       Call WriteProcessMemory(hProcess, ByVal rcAddr, rc, Len(rc), lWritten)
       Call SendMessage(hSB, SB_GETRECT, i, ByVal rcAddr)
       Call ReadProcessMemory(hProcess, ByVal rcAddr, rc, Len(rc), lWritten)
       
       hIcon = SendMessage(hSB, SB_GETICON, i, ByVal 0&)
       
       ret = Abs(rc.Right - rc.Left)
       If ret >= 0 Then
          With sb.Panels.Add()
              .Text = sText
              .ToolTipText = sTip
              .Width = IIf(ret > 0, ret * Screen.TwipsPerPixelX, 1)
              If ret = 0 And sText <> "" Then .AutoSize = sbrContents
              If rc.Left < 0 Then .Width = .Width - rc.Left * Screen.TwipsPerPixelX
              If lBevel = SBT_NOBORDERS Then
                 .Bevel = sbrNoBevel
              ElseIf lBevel = SBT_POPOUT Then
                 .Bevel = sbrRaised
              Else
                 .Bevel = sbrInset
              End If
              If hIcon Then
                 Set sPic = IconToPicture(hIcon)
                 .Picture = sPic
                 Set sPic = Nothing
              End If
              .Tag = Int(.Width / Screen.TwipsPerPixelX) & "_" & rc.Bottom - rc.Top & "_" & CBool(.AutoSize) & "_" & CStr(lBevel)
          End With
       End If
   Next i
   VirtualFreeEx hProcess, ByVal rcAddr, 0, MEM_RELEASE
   VirtualFreeEx hProcess, ByVal itAddr, 0, MEM_RELEASE
CleanUp:
   If hProcess Then CloseHandle hProcess
   SB_Duplicate = nCount
End Function

