Attribute VB_Name = "mTBDuplicate"
Option Explicit

Private Type TBBUTTONINFO ''Toolbar button info
   cbSize As Long
   dwMask As Long
   idCommand As Long
   iImage As Long
   fsState As Byte
   fsStyle As Byte
   cx As Integer
   lParam As Long
   pszText As Long
   cchText As Long
End Type

Private Type ITEM_TEXT
   pszText As String * 80
End Type

Private Const WM_USER = &H400&
Private Const TB_BUTTONCOUNT = (WM_USER + 24)
Private Const TB_GETBUTTONINFO = (WM_USER + 65)

Private Const TB_GETIMAGELIST = (WM_USER + 49)
Private Const TB_GETHOTIMAGELIST = (WM_USER + 53)
Private Const TB_GETDISABLEDIMAGELIST = (WM_USER + 55)

Private Const TB_GETBUTTONTEXT = (WM_USER + 45)
Private Const TB_GETSTRING = (WM_USER + 92)
Private Const TB_GETEXTENDEDSTYLE = (WM_USER + 85)

Private Const TBIF_IMAGE = &H1
Private Const TBIF_TEXT = &H2
Private Const TBIF_STATE = &H4
Private Const TBIF_STYLE = &H8
Private Const TBIF_LPARAM = &H10
Private Const TBIF_COMMAND = &H20
Private Const TBIF_SIZE = &H40
Private Const TBIF_ALL = TBIF_IMAGE Or TBIF_STATE Or _
                         TBIF_STYLE Or TBIF_LPARAM Or TBIF_COMMAND _
                         Or TBIF_SIZE Or TBIF_TEXT

Private Const TBIF_BYINDEX = &H80000000

Private Const TBSTATE_CHECKED = &H1
Private Const TBSTATE_PRESSED = &H2
Private Const TBSTATE_ENABLED = &H4
Private Const TBSTATE_HIDDEN = &H8
Private Const TBSTATE_INDETERMINATE = &H10
Private Const TBSTATE_WRAP = &H20
Private Const TBSTATE_ELLIPSES = &H40
Private Const TBSTATE_MARKED = &H80

Private Const TBSTYLE_BUTTON = &H0
Private Const TBSTYLE_SEP = &H1
Private Const TBSTYLE_CHECK = &H2
Private Const TBSTYLE_GROUP = &H4
Private Const TBSTYLE_CHECKGROUP = (TBSTYLE_GROUP Or TBSTYLE_CHECK)
Private Const TBSTYLE_DROPDOWN = &H8
Private Const TBSTYLE_AUTOSIZE = &H10
Private Const TBSTYLE_NOPREFIX = &H20
Private Const BTNS_SHOWTEXT = &H40
Private Const BTNS_WHOLEDROPDOWN = &H80  'draw drop-down arrow, but without split arrow section
Private Const TBSTYLE_TOOLTIPS = &H100
Private Const TBSTYLE_WRAPABLE = &H200
Private Const TBSTYLE_ALTDRAG = &H400
Private Const TBSTYLE_FLAT = &H800
Private Const TBSTYLE_LIST = &H1000
Private Const TBSTYLE_CUSTOMERASE = &H2000
Private Const TBSTYLE_REGISTERDROP = &H4000
Private Const TBSTYLE_TRANSPARENT = &H8000

Private Const TBSTYLE_EX_DRAWDDARROWS = &H1
Private Const TBSTYLE_EX_MIXEDBUTTONS = &H8
Private Const TBSTYLE_EX_HIDECLIPPEDBUTTONS = &H10 'don't show partially obscured buttons
Private Const TBSTYLE_EX_DOUBLEBUFFER = &H80       'Double Buffer the toolbar

Public Function TB_Duplicate(ByVal hTB As Long, tb As Toolbar, _
                             Optional ImageList_Normal As ImageList, _
                             Optional ImageList_Disabled As ImageList, _
                             Optional ImageList_Hot As ImageList, _
                             Optional bShowHiddenItems As Boolean, _
                             Optional bShowHiddentext As Boolean, _
                             Optional bHideText As Boolean _
                             ) As Long
   
   Dim tid As Long, pid As Long, hProcess As Long
   Dim nCount As Long, i As Long, lStyle As Long, lExtStyle As Long, lTbrStyle As Long
   Dim tbiAddr As Long, itAddr As Long, lWritten As Long
   Dim hIml_Normal As Long, hIml_Disabled As Long, hIml_Hot As Long
   Dim nIcons As Long, nDisabledIcons As Long, nHotIcons As Long
   Dim sText As String, sTip As String, sTbrInfo As String
   
   Dim tbi As TBBUTTONINFO
   Dim it As ITEM_TEXT
   
   tb.Buttons.Clear
   Set tb.ImageList = Nothing
   Set tb.DisabledImageList = Nothing
   Set tb.HotImageList = Nothing
   lTbrStyle = GetWindowLong(hTB, GWL_STYLE)
   lExtStyle = SendMessage(hTB, TB_GETEXTENDEDSTYLE, 0, ByVal 0&)
   
   AdjustStyle lTbrStyle, tb
   
   nCount = SendMessage(hTB, TB_BUTTONCOUNT, 0, ByVal 0)
   sTbrInfo = CStr(nCount) & "_" & CStr(lTbrStyle) & "_" & CStr(lExtStyle)
   tb.Tag = sTbrInfo
   If nCount = 0 Then
      Exit Function
   End If
   If Not EnableDebugPrivNT Then Exit Function
   tid = GetWindowThreadProcessId(hTB, pid)
   If pid = 0 Then Exit Function
   hProcess = OpenProcess(PROCESS_ALL_ACCESS, False, pid)
   If hProcess = 0 Then Exit Function
   
   hIml_Normal = SendMessage(hTB, TB_GETIMAGELIST, 0, ByVal 0&)
   hIml_Disabled = SendMessage(hTB, TB_GETDISABLEDIMAGELIST, 0, ByVal 0&)
   hIml_Hot = SendMessage(hTB, TB_GETHOTIMAGELIST, 0, ByVal 0&)
   
   If hIml_Normal Then
      If Not ImageList_Normal Is Nothing Then
         nIcons = IL_Duplicate(hProcess, hIml_Normal, ImageList_Normal)
         ImageList_Normal.BackColor = vbButtonFace
         Set tb.ImageList = ImageList_Normal
      End If
   End If
   If hIml_Disabled Then
      If Not ImageList_Disabled Is Nothing Then
         nDisabledIcons = IL_Duplicate(hProcess, hIml_Disabled, ImageList_Disabled)
         ImageList_Disabled.BackColor = vbButtonFace
         Set tb.DisabledImageList = ImageList_Disabled
      End If
   End If
   If hIml_Hot Then
      If Not ImageList_Hot Is Nothing Then
         nHotIcons = IL_Duplicate(hProcess, hIml_Hot, ImageList_Hot)
         ImageList_Hot.BackColor = vbButtonFace
         Set tb.ImageList = ImageList_Hot
      End If
   End If
   sTbrInfo = sTbrInfo & "_" & CStr(nIcons) & "_" & CStr(nDisabledIcons) & "_" & CStr(nHotIcons)
   tb.Tag = sTbrInfo
   
   tbiAddr = VirtualAllocEx(hProcess, 0, Len(tbi), MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE)
   itAddr = VirtualAllocEx(hProcess, 0, Len(it), MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE)
   For i = 0 To nCount - 1
       ZeroMemory tbi, Len(tbi)
       ZeroMemory it, Len(it)
       tbi.cbSize = Len(tbi)
       tbi.cchText = Len(it)
       tbi.pszText = itAddr
       tbi.dwMask = TBIF_ALL Or TBIF_BYINDEX
       Call WriteProcessMemory(hProcess, ByVal tbiAddr, tbi, Len(tbi), lWritten)
       Call WriteProcessMemory(hProcess, ByVal itAddr, it, Len(it), lWritten)
       Call SendMessage(hTB, TB_GETBUTTONINFO, i, ByVal tbiAddr)
       Call ReadProcessMemory(hProcess, ByVal tbiAddr, tbi, Len(tbi), lWritten)
       Call ReadProcessMemory(hProcess, ByVal itAddr, it, Len(it), lWritten)
       sText = "": sTip = ""
       sText = TrimNull(it.pszText)
       Call SendMessage(hTB, TB_GETBUTTONTEXT, tbi.idCommand, ByVal itAddr)
       Call ReadProcessMemory(hProcess, ByVal itAddr, it, Len(it), lWritten)
       sTip = TrimNull(it.pszText)
       If tbi.cx = 0 Then
          If Not CBool(tbi.fsStyle And TBSTYLE_AUTOSIZE) Then sText = ""
       End If
       If lTbrStyle And TBSTYLE_LIST Then
          If (sText = "") Then sText = sTip
       End If
       If lExtStyle And TBSTYLE_EX_MIXEDBUTTONS Then
          If tbi.fsStyle And BTNS_SHOWTEXT Then
             If (sText = "") Then sText = sTip
          Else
             sText = ""
          End If
       End If
       If bShowHiddentext Then
          If (sText = "") Then sText = sTip
       End If
       With tb.Buttons.Add()
           If Not bHideText Then .Caption = sText
'           .Width = tbi.cx * Screen.TwipsPerPixelX
           .Enabled = (tbi.fsState And TBSTATE_ENABLED)
           .Value = IIf(tbi.fsState And TBSTATE_PRESSED, tbrPressed, tbrUnpressed)
           .MixedState = (tbi.fsState And TBSTATE_INDETERMINATE)
           Select Case (tbi.fsStyle And &HBF) And Not &H40
                  Case TBSTYLE_BUTTON
                  Case TBSTYLE_SEP:        .Style = tbrSeparator
                  Case TBSTYLE_CHECK:      .Style = tbrCheck
                  Case TBSTYLE_GROUP:      .Style = tbrButtonGroup
                  Case TBSTYLE_CHECKGROUP: .Style = tbrCheck + tbrButtonGroup
                  Case TBSTYLE_DROPDOWN, _
                       BTNS_WHOLEDROPDOWN: .Style = tbrDropdown
           End Select
           On Error Resume Next
              .Image = tbi.iImage + 1
           On Error GoTo 0
           .ToolTipText = sTip
           If Not bShowHiddenItems Then
              .Visible = Not CBool(tbi.fsState And TBSTATE_HIDDEN)
           End If
           .Tag = CStr(tbi.fsState) & "_" & CStr(tbi.fsStyle) & "_" & CStr(tbi.cx) & "_" & CStr(tbi.idCommand)
       End With
   Next i
   VirtualFreeEx hProcess, ByVal tbiAddr, 0, MEM_RELEASE
   VirtualFreeEx hProcess, ByVal itAddr, 0, MEM_RELEASE
CleanUp:
   If hProcess Then CloseHandle hProcess
End Function

Private Sub AdjustStyle(ByVal lStyle As Long, tb As Toolbar)
'Adjust styles
   tb.Style = IIf((lStyle And TBSTYLE_FLAT), tbrFlat, tbrStandard)
   tb.TextAlignment = IIf((lStyle And TBSTYLE_LIST), tbrTextAlignRight, tbrTextAlignBottom)
   tb.Wrappable = (lStyle And TBSTYLE_WRAPABLE)
'   tb.ShowTips = (lStyle And TBSTYLE_TOOLTIPS)
End Sub

Public Function TranslateButtonState(ByVal lState As Long) As String
   Dim s As String
   Dim sTab As String
   sTab = Space(4)
   s = "Button state(s):" & vbCrLf & sTab
   If lState And TBSTATE_ENABLED Then
      s = s & "Enabled"
   Else
      s = s & "Disabled"
   End If
   If lState And TBSTATE_CHECKED Then s = s & vbCrLf & sTab & "Checked"
   If lState And TBSTATE_PRESSED Then s = s & vbCrLf & sTab & "Pressed"
   If lState And TBSTATE_HIDDEN Then s = s & vbCrLf & sTab & "Hidden"
   If lState And TBSTATE_INDETERMINATE Then s = s & vbCrLf & sTab & "Mixed"
   If lState And TBSTATE_WRAP Then s = s & vbCrLf & sTab & "Wrapped"
   If lState And TBSTATE_ELLIPSES Then s = s & vbCrLf & sTab & "Ellipsed"
   If lState And TBSTATE_MARKED Then s = s & vbCrLf & sTab & "Marked"
   TranslateButtonState = s
End Function

Public Function TranslateButtonStyle(ByVal lStyle As Long) As String
   Dim s As String
   Dim sTab As String
   sTab = Space(4)
   s = "Button style(s):" & vbCrLf & sTab
   Select Case (lStyle And &HBF) And Not &H40
      Case TBSTYLE_SEP:        s = s & "Separator"
      Case TBSTYLE_CHECK:      s = s & "Check button"
      Case TBSTYLE_GROUP:      s = s & "Group"
      Case TBSTYLE_CHECKGROUP: s = s & "Check group"
      Case TBSTYLE_DROPDOWN:   s = s & "Drop down"
      Case BTNS_WHOLEDROPDOWN: s = s & "Whole DropDown"
      Case Else:               s = s & "Button"
   End Select
   If lStyle And TBSTYLE_AUTOSIZE Then s = s & vbCrLf & sTab & "Autosize"
   If lStyle And TBSTYLE_NOPREFIX Then s = s & vbCrLf & sTab & "No prefix"
   If lStyle And BTNS_SHOWTEXT Then s = s & vbCrLf & sTab & "Show Text"
   TranslateButtonStyle = s
End Function

Public Function TranslateToolBarStyle(ByVal lStyle As Long) As String
   Dim s As String
   Dim sTab As String
   sTab = Space(4)
   s = "ToolBar style(s):"
   s = s & vbCrLf & sTab & "Show Tips:" & vbTab & YesNoBoolean(lStyle And TBSTYLE_TOOLTIPS)
   s = s & vbCrLf & sTab & "Wrapable:" & vbTab & YesNoBoolean(lStyle And TBSTYLE_WRAPABLE)
   s = s & vbCrLf & sTab & "Alt drag:" & vbTab & YesNoBoolean(lStyle And TBSTYLE_ALTDRAG)
   s = s & vbCrLf & sTab & "Flat:" & vbTab & vbTab & YesNoBoolean(lStyle And TBSTYLE_FLAT)
   s = s & vbCrLf & sTab & "Transparent:" & vbTab & YesNoBoolean(lStyle And TBSTYLE_TRANSPARENT)
   s = s & vbCrLf & sTab & "Text align:" & vbTab & IIf((lStyle And TBSTYLE_LIST), "Right", "Bottom")
   s = s & vbCrLf & sTab & "Accept drop:" & vbTab & YesNoBoolean(TBSTYLE_REGISTERDROP)
   TranslateToolBarStyle = s
End Function

Public Function TranslateToolBarExStyle(ByVal lStyle As Long) As String
   If lStyle = 0 Then Exit Function
   Dim s As String
   Dim sTab As String
   sTab = Space(4)
   s = "Extended ToolBar style(s):"
   If lStyle And TBSTYLE_EX_DRAWDDARROWS Then s = s & vbCrLf & sTab & "Draw DD Arrow"
   If lStyle And TBSTYLE_EX_MIXEDBUTTONS Then s = s & vbCrLf & sTab & "Mixed buttons"
   If lStyle And TBSTYLE_EX_HIDECLIPPEDBUTTONS Then s = s & vbCrLf & sTab & "Hide clipped buttons"
   If lStyle And TBSTYLE_EX_DOUBLEBUFFER Then s = s & vbCrLf & sTab & "Double buffered"
   TranslateToolBarExStyle = s
End Function

Private Function YesNoBoolean(ByVal bVal As Boolean) As String
   YesNoBoolean = IIf(bVal, "Yes", "No")
End Function
