Attribute VB_Name = "mTVDuplicate"
Option Explicit

Private Type TV_ITEM
  mask As Long
  hitem As Long
  state As Long
  stateMask As Long
  pszText As Long
  cchTextMax As Long
  iImage As Long
  iSelectedImage As Long
  cChildren As Long
  lParam As Long
End Type

Private Type ITEM_TEXT
   pszText As String * 80
End Type

Private Const TV_FIRST = &H1100
Private Const TVM_GETCOUNT = (TV_FIRST + 5)
Private Const TVM_GETINDENT = (TV_FIRST + 6)
Private Const TVM_GETIMAGELIST = (TV_FIRST + 8)
Private Const TVM_GETNEXTITEM = (TV_FIRST + 10)
Private Const TVM_GETITEM = (TV_FIRST + 12)
Private Const TVM_GETBKCOLOR = (TV_FIRST + 31)

Private Const TVI_ROOT = &HFFFF0000
Private Const TVI_FIRST = &HFFFF0001
Private Const TVI_LAST = &HFFFF0002
Private Const TVI_SORT = &HFFFF0003

Private Const TVGN_ROOT = &H0
Private Const TVGN_NEXT = &H1
Private Const TVGN_CHILD = &H4

Private Const TVIF_TEXT = &H1
Private Const TVIF_IMAGE = &H2
Private Const TVIF_PARAM = &H4
Private Const TVIF_STATE = &H8
Private Const TVIF_HANDLE = &H10
Private Const TVIF_SELECTEDIMAGE = &H20
Private Const TVIF_CHILDREN = &H40
Private Const TVIF_ALL = TVIF_TEXT Or TVIF_IMAGE Or TVIF_HANDLE Or TVIF_HANDLE Or TVIF_STATE Or _
                         TVIF_HANDLE Or TVIF_SELECTEDIMAGE Or TVIF_CHILDREN

Private Const TVIS_FOCUSED = &H1
Private Const TVIS_SELECTED = &H2
Private Const TVIS_CUT = &H4
Private Const TVIS_DROPHILITED = &H8
Private Const TVIS_BOLD = &H10
Private Const TVIS_EXPANDED = &H20
Private Const TVIS_OVERLAYMASK = &HF00
Private Const TVIS_STATEIMAGEMASK = &HF000

Private Const TVSIL_NORMAL = 0
Private Const TVSIL_STATE = 2

Private Const TVS_HASBUTTONS = &H1
Private Const TVS_HASLINES = &H2
Private Const TVS_LINESATROOT = &H4
Private Const TVS_EDITLABELS = &H8
Private Const TVS_DISABLEDRAGDROP = &H10
Private Const TVS_SHOWSELALWAYS = &H20
Private Const TVS_RTLREADING = &H40
Private Const TVS_NOTOOLTIPS = &H80
Private Const TVS_CHECKBOXES = &H100
Private Const TVS_TRACKSELECT = &H200
Private Const TVS_SINGLEEXPAND = &H400
Private Const TVS_INFOTIP = &H800
Private Const TVS_FULLROWSELECT = &H1000
Private Const TVS_NOSCROLL = &H2000
Private Const TVS_NONEVENHEIGHT = &H4000
Private Const CLR_NONE = -1

Public Function TV_Duplicate(ByVal hTV As Long, tv As TreeView, _
                             Optional ByVal ImageList_Normal As ImageList, _
                             Optional ByVal ImageList_State As ImageList) As Long
   
   Dim tid As Long, pid As Long, hProcess As Long
   Dim nCount As Long, hRoot As Long
   Dim tiAddr As Long, itAddr As Long, lWritten As Long
   Dim hIml_Normal As Long, hIml_State As Long
   Dim nIcons As Long, nStateIcons As Long, bkColor As Long
   Dim nd As Node
   
   Dim ti As TV_ITEM
   Dim it As ITEM_TEXT
   
   tv.Nodes.Clear
   Set tv.ImageList = Nothing
   AdjustStyle hTV, tv
   bkColor = SendMessage(hTV, TVM_GETBKCOLOR, 0, ByVal 0&)
   If bkColor = CLR_NONE Then bkColor = vbWindowBackground
   
   If SendMessage(hTV, TVM_GETCOUNT, 0, ByVal 0) = 0 Then
      tv.Nodes.Add , , , "TreeView is empty"
      Exit Function
   End If
   If Not EnableDebugPrivNT Then Exit Function
   tid = GetWindowThreadProcessId(hTV, pid)
   If pid = 0 Then Exit Function
   hProcess = OpenProcess(PROCESS_ALL_ACCESS, False, pid)
   If hProcess = 0 Then Exit Function
   
   hIml_Normal = SendMessage(hTV, TVM_GETIMAGELIST, TVSIL_NORMAL, ByVal 0&)
   hIml_State = SendMessage(hTV, TVM_GETIMAGELIST, TVSIL_STATE, ByVal 0&)
   
   If hIml_Normal Then
      If Not ImageList_Normal Is Nothing Then
         nIcons = IL_Duplicate(hProcess, hIml_Normal, ImageList_Normal)
         ImageList_Normal.BackColor = vbWindowBackground
         Set tv.ImageList = ImageList_Normal
         tv.Style = tv.Style + 1
      End If
   End If
   
'   If hIml_State Then
'      If Not ImageList_State Is Nothing Then
'         nStateIcons = IL_Duplicate(hProcess, hIml_State, ImageList_State)
'      End If
'   Else
'      If nIcons Then
'         nStateIcons = nIcons
'      End If
'   End If
   
   tiAddr = VirtualAllocEx(hProcess, 0, Len(ti), MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE)
   itAddr = VirtualAllocEx(hProcess, 0, LenB(it), MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE)
   
   EnumTVNodes hTV, tiAddr, itAddr, hProcess, 0, 0, tv, True
   
   VirtualFreeEx hProcess, ByVal tiAddr, 0, MEM_RELEASE
   VirtualFreeEx hProcess, ByVal itAddr, 0, MEM_RELEASE
CleanUp:
   Set nd = Nothing
   If hProcess Then CloseHandle hProcess
End Function

Private Sub AdjustStyle(ByVal hTV As Long, tv As TreeView)
   Dim lStyle As Long
   lStyle = GetWindowLong(hTV, GWL_STYLE)
'Set default styles
   tv.Style = tvwTextOnly
   tv.LabelEdit = tvwManual
   tv.HideSelection = True
'Adjust styles
   If lStyle And TVS_HASBUTTONS Then tv.Style = tvwPlusMinusText
   If lStyle And TVS_HASLINES Then tv.Style = tv.Style + 4
   If lStyle And TVS_LINESATROOT Then tv.LineStyle = tvwRootLines
   If lStyle And TVS_EDITLABELS Then tv.LabelEdit = tvwAutomatic
   If lStyle And TVS_SHOWSELALWAYS Then tv.HideSelection = False
   tv.Checkboxes = CBool(lStyle And TVS_CHECKBOXES)
   tv.HotTracking = CBool(lStyle And TVS_TRACKSELECT)
   tv.SingleSel = CBool(lStyle And TVS_SINGLEEXPAND)
   tv.FullRowSelect = CBool(lStyle And TVS_FULLROWSELECT)
   tv.Indentation = SendMessage(hTV, TVM_GETINDENT, 0, ByVal 0) * Screen.TwipsPerPixelX
End Sub

Private Function EnumTVNodes(ByVal hTV As Long, ByVal tiAddr As Long, ByVal itAddr As Long, _
                             ByVal hProcess As Long, hParent As Long, iParent As Long, _
                             tv As TreeView, Optional ByVal bRoot As Boolean) As Long
   Dim hChild As Long
   Dim nItems As Long, lWritten As Long
   Dim ndChild As Node
   Dim ti As TV_ITEM
   Dim it As ITEM_TEXT

   If bRoot Then
      hChild = SendMessage(hTV, TVM_GETNEXTITEM, 0, TVGN_ROOT)
   Else
      hChild = SendMessage(hTV, TVM_GETNEXTITEM, TVGN_CHILD, ByVal hParent)
   End If
   
   Do While hChild
      nItems = nItems + 1
      ZeroMemory ti, Len(ti)
      ZeroMemory it, Len(it)
      ti.cchTextMax = Len(it)
      ti.mask = TVIF_ALL
      ti.pszText = itAddr
      ti.hitem = hChild
      WriteProcessMemory hProcess, ByVal tiAddr, ti, Len(ti), lWritten
      WriteProcessMemory hProcess, ByVal itAddr, it, Len(it), lWritten
      Call SendMessage(hTV, TVM_GETITEM, 0, ByVal tiAddr)
      ReadProcessMemory hProcess, ByVal tiAddr, ti, Len(ti), lWritten
      ReadProcessMemory hProcess, ByVal itAddr, it, Len(it), lWritten
      If tv.ImageList Is Nothing Then ti.iImage = -1
      If TrimNull(it.pszText) = "" Then
         it.pszText = "This node uses callback. Expand it in target app to get text."
         ti.iImage = -1
      End If
      If tv.ImageList.ListImages.Count < ti.iImage Then ti.iImage = tv.ImageList.ListImages.Count - 1
      If bRoot Then
         Set ndChild = tv.Nodes.Add(, , , TrimNull(it.pszText), ti.iImage + 1)
      Else
         Set ndChild = tv.Nodes.Add(iParent, tvwChild, , TrimNull(it.pszText), ti.iImage + 1)
      End If
      If (ti.state And TVIS_EXPANDED) Then ndChild.Expanded = True
      Call EnumTVNodes(hTV, tiAddr, itAddr, hProcess, hChild, ndChild.Index, tv)
      hChild = SendMessage(hTV, TVM_GETNEXTITEM, TVGN_NEXT, ByVal hChild)
  Loop
  EnumTVNodes = nItems
End Function
